package jp.objectfanatics.assertion.weaver.api.assertionweaver;

import javassist.CtClass;

public interface AssertionWeaver {

	/**
	 * Returns whether the specified type is supported or not.
	 * 
	 * @param targetValueType
	 *            type of the target parameter or return value
	 * @return whether the specified type is supported or not
	 */
	boolean isSupported(CtClass targetValueType);
}
