package jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.assertionconditiongenerator;

import static jp.objectfanatics.commons.javassist.JavassistUtils.isBigDecimal;
import javassist.CtBehavior;
import javassist.CtClass;
import jp.objectfanatics.assertion.weaver.impl.annotationprocessor.numbercomparing.AbstractNumberComparingAssertionWeaver.ThresholdOutOfBoundsException;

public class BigDecimalAssertionConditionExpressionGenerator extends ComparableNumberAssertionConditionExpressionGeneratorBase {

	public BigDecimalAssertionConditionExpressionGenerator(String comparativeOperator, Class<? extends java.lang.annotation.Annotation> targetConstraintAnnotation) {
		super(comparativeOperator, targetConstraintAnnotation);
	}
	
	@Override
	protected String getAssertionTargetValueExpression(CtBehavior ctBehavior, CtClass type, String valueIdentifier, double threshold) throws ThresholdOutOfBoundsException {
		// TODO:昔のコードが、なぜか下記のように double にキャストしていたのだが、理由が思い出せないし、意味がなさそうなので、とりあえずはずした。ということで、問題がないという裏をとりましょう。
		//		return valueIdentifier + ".doubleValue() " + comparativeOperator + " (double)" + threshold;
		return valueIdentifier + ".doubleValue()";
	}

	@Override
	public boolean isSupported(CtClass type) {
		return isBigDecimal(type);
	}
}
