/*
 * Copyright (C) 2005-2009 Makoto Sato. All Rights Reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package jp.objectfanatics.assertion.weaver.api.core.exception;

//DOUBLE_CHECKED 04.04.2010
// TODO: 全体的に、interface　レベルで出てくる例外については、特定の interface 依存の場合は、そのインナークラスとして扱うようにする。
/**
 * Signals that line number is not available.
 * 
 * @author Makoto Sato
 */
public class LineNumberNotAvailableException extends Exception {}
